using System;
using System.Collections.Generic;
using System.Text;
using System.Net;
using System.Security.Principal;
using System.Security.Authentication;

namespace PowerShellRemoting
{
    internal  abstract class SecureChannel
    {
        internal  abstract string Name { get; }

        internal  abstract bool IsAuthenticated { get;}

        internal  abstract WindowsIdentity Identity { get;}

        internal  abstract void OpenAsClient(NetworkCredential cre, string target);

        internal  abstract void OpenAsServer();

        internal  abstract void Close();

        internal  abstract string ReadText();

        internal  abstract void WriteText(string message);

        internal  abstract int ReadData(byte[] buffer, int offset, int count);

        internal  abstract void WriteData(byte[] buffer, int offset, int count);

        internal  abstract void SendCommand(int cmd);

        internal  abstract int ReceiveCommand();

        internal  abstract bool SetWriteTimeout(int milliseconds);

        internal  abstract bool UnsetWriteTimeout();

        internal  abstract bool SetReadTimeout(int milliseconds);

        internal  abstract bool UnsetReadTimeout();

        internal  const int OK = 100;
        internal  const int Error = int.MaxValue;
        internal  const int Cancal = 102;
        internal  const int Exit = 103;
        internal  const int ReadLine = 201;
        internal  const int ReadLineAsSecureString = 202;
        internal  const int PromptForChoice = 203;
        internal  const int PromptForCredential = 204;
        internal  const int Write = 301;
        internal  const int WriteColor = 302;
        internal  const int WriteEmptyLine = 303;
        internal  const int WriteLine = 304;
        internal  const int WriteLineColor = 305;
        internal  const int WriteErrorLine = 306;
        internal  const int WriteVerboseLine = 307;
        internal  const int WriteDebugLine = 308;
        internal  const int WriteWarningLine = 309;
        internal  const int WriteProgress = 401;
        internal  const int RawGetBackgroundColor = 501;
        internal  const int RawSetBackgroundColor = 502;
        internal  const int RawGetForegroundColor = 503;
        internal  const int RawSetForegroundColor = 504;
        internal  const int RawGetBufferSize = 505;
        internal  const int RawSetBufferSize = 506;
        internal  const int RawGetCursorPosition = 507;
        internal  const int RawSetCursorPosition = 508;
        internal  const int RawGetCursorSize = 509;
        internal  const int RawSetCursorSize = 510;
        internal  const int RawKeyAvailable = 511;
        internal  const int RawGetMaxPhysicalWindowSize = 512;
        internal  const int RawGetMaxWindowSize = 513;
        internal  const int RawGetWindowPosition = 514;
        internal  const int RawSetWindowPosition = 515;
        internal  const int RawGetWindowSize = 516;
        internal  const int RawSetWindowSize = 517;
        internal  const int RawGetWindowTitle = 518;
        internal  const int RawSetWindowTitle = 519;
        internal  const int RawReadKey = 520;
        internal  const int RawFlushInputBuffer = 521;
        internal  const int RawScrollBufferContents = 522;
        internal  const int RawSetBufferContents1 = 523;
        internal  const int RawSetBufferContents2 = 524;
        internal  const int RawGetBufferContents = 525;

        internal  const string EmptyLine = "~~EmptyLine";
        internal  const string ErrorLine = "~~ErrorLine";

    }
}
