using System;
using System.Collections;
using System.Configuration.Install;
using System.ServiceProcess;
using System.ComponentModel;


namespace PowerShellRemoting
{
    [RunInstallerAttribute(true)]
    public class PowerShellRemotingInstaller : Installer
    {
        private ServiceInstaller serviceInstaller1;
        private ServiceProcessInstaller processInstaller1;

        public PowerShellRemotingInstaller()
        {
            this.processInstaller1 = new ServiceProcessInstaller();
            this.serviceInstaller1 = new ServiceInstaller();

            processInstaller1.Account = ServiceAccount.NetworkService;

            serviceInstaller1.StartType = ServiceStartMode.Manual;
            serviceInstaller1.ServiceName = "PowerShellRemoting";
            serviceInstaller1.DisplayName = "PowerShell Remoting";
            serviceInstaller1.Description = "A Network Service providing remote access to Microsoft Command Shell (Monad) by http://MSHForFun.blogspot.com/";

            Installers.Add(serviceInstaller1);
            Installers.Add(processInstaller1);

        }

        public override void Install(IDictionary stateSaver)
        {
            Microsoft.Win32.RegistryKey system,currentControlSet,services,service,config;
            try
            {
                base.Install(stateSaver);
                system = Microsoft.Win32.Registry.LocalMachine.OpenSubKey("System");
                currentControlSet = system.OpenSubKey("CurrentControlSet");
                services = currentControlSet.OpenSubKey("Services");
                service = services.OpenSubKey(this.serviceInstaller1.ServiceName, true);
                config = service.CreateSubKey("Parameters");
                config.SetValue("Port", 8080, Microsoft.Win32.RegistryValueKind.DWord);
                config.SetValue("MaxClient", 10, Microsoft.Win32.RegistryValueKind.DWord);
                config.SetValue("MaxClientPerIP", 2, Microsoft.Win32.RegistryValueKind.DWord);
                config.SetValue("DebugHost", 0, Microsoft.Win32.RegistryValueKind.DWord);
                config.SetValue("X509", "0", Microsoft.Win32.RegistryValueKind.String);
            }
            catch (Exception ex)
            {
                Console.WriteLine(string.Format("{0}",ex));
            }
        }

        public override void Uninstall(IDictionary savedState)
        {
            Microsoft.Win32.RegistryKey system, currentControlSet,services,service;
            try
            {
                system = Microsoft.Win32.Registry.LocalMachine.OpenSubKey("System");
                currentControlSet = system.OpenSubKey("CurrentControlSet");
                services = currentControlSet.OpenSubKey("Services");
                service = services.OpenSubKey(this.serviceInstaller1.ServiceName, true);
                service.DeleteSubKeyTree("Parameters");
            }
            catch (Exception ex)
            {
                Console.WriteLine(string.Format("{0}", ex));
            }
            finally
            {
                base.Uninstall(savedState);
            }
        }


    }
}
