using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using System.Security;

namespace PowerShellRemoting
{
    internal class SecureStringHelper
    {
        internal static string GetStringFromSecureString(SecureString ss)
        {
            IntPtr ptr1 = Marshal.SecureStringToGlobalAllocUnicode(ss);
            string text1 = Marshal.PtrToStringUni(ptr1);
            Marshal.ZeroFreeGlobalAllocUnicode(ptr1);
            return text1;
        }

        internal static byte[] GetByteFromSecureString(SecureString s)
        {
            byte[] buffer1 = new byte[s.Length * 2];
            ushort num1 = 0;
            if (s.Length > 0)
            {
                IntPtr ptr1 = Marshal.SecureStringToGlobalAllocUnicode(s);
                try
                {
                    for (int num2 = 0; num2 < s.Length; num2++)
                    {
                        num1 = (ushort)Marshal.ReadInt16(ptr1, num2 * 2);
                        buffer1[2 * num2] = (byte)(num1 % 0x100);
                        buffer1[(2 * num2) + 1] = (byte)(num1 / 0x100);
                    }
                }
                finally
                {
                    Marshal.FreeHGlobal(ptr1);
                }
            }
            return buffer1;
        }

        internal static SecureString NewSecureString(byte[] data, int Length)
        {
           if((Length % 2) != 0)
               throw new ArgumentException("SecureStringHelper.New: data has odd length");
            SecureString text1 = new SecureString();
            int num1 = Length / 2;
            for (int num2 = 0; num2 < num1; num2++)
            {
                char ch1 = (char)((ushort)((data[(2 * num2) + 1] * 0x100) + data[2 * num2]));
                text1.AppendChar(ch1);
                data[2 * num2] = 0;
                data[(2 * num2) + 1] = 0;
            }
            return text1;
        }


    }
}
